#include<bits/stdc++.h>
#define lli long long
#define endl "\n"
using namespace std;
const lli INF=9999999999999, MAXN=100005;
lli N, p1, p2, ans, sz[MAXN], in[MAXN], koren, Q;
vector<lli> v[MAXN];
void dfs(lli vr){
    sz[vr]=1;
    for(lli i=0; i<v[vr].size(); i++){
        dfs(v[vr][i]);
        sz[vr]+=sz[v[vr][i]];
    }
    return;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N;
    for(lli i=0; i<N-1; i++){
        cin>>p1>>p2;
        v[p1].push_back(p2);
        in[p2]++;
    }
    for(lli i=1; i<=N; i++){
        if(in[i]==0){
            koren=i;
            break;
        }
    }
    dfs(koren);
    cin>>Q;
    for(lli i=0; i<Q; i++){
        cin>>p1;
        cout<<sz[p1]-1<<endl;
    }
    return 0;
}
